% 'Matchine' software by Joan Alexis Glaunes, Copyright (C) Universite Paris Descartes, All Rights Reserved 2005-2006, version 1.0
%
% Any use of this code should make reference to at least one of the following references:
%
% - [for the use of 'measure matching']:
% J. Glaunes, L. Younes and A. Trouve, Diffeomorphic matching of distributions: A new approach for unlabelled point-sets and sub-manifolds matching, Proc. of the 2004 IEEE Computer Society Conference on Computer Vision and Pattern Recognition. (CVPR'04), Vol. 2, pp. 712--718, DOI: 10.1109/CVPR.2004.81
%
% - [for the use of 'curve matching']:
% J. Glaunes, A. Qiu, M. Miller, L. Younes, Large Deformation Diffeomorphic Metric Curve Mapping, International Journal of Computer vision, Springer, 2008, Vol. 80, No. 3, pp. 317--336, DOI: 10.1007/s11263-008-0141-9
%
% - [for the use of 'surface matching']:
% M. Vaillant and J. Glaunes, Surface Matching via Currents, Proc. of Information Processing in Medical Imaging (IPMI'05), Lecture Notes in Computer Science vol. 3565, Springer 2005, pp. 381--392



function savestruct(sname,field)

% save workspace variables in structure 
% savestruct('s') only updates fields which are already defined in s 
%
% savestruct('s',field) specify the list of fields

if nargin==1
   field = evalin('caller',['fieldnames(',sname,')']);
end

for n = 1:length(field)
   fld = field{n};
   if ~strcmp(sname,fld)  % prevent from saving structure inside itself..
       evalin('caller',[sname,'.',fld,'=eval(''',fld,''',''eval(''''',sname,'.',fld,''''',''''0;'''')'');']);
   end
end

